blob: 913d7f8ef93862ea0ecfd1174dcf8ddf28e61e35 [file] [log] [blame]
Rob Landley16890752005-09-02 00:41:53 +00001# Simple test harness infrastructurei for BusyBox
2#
3# Copyright 2005 by Rob Landley
4#
5# License is GPLv2, see LICENSE in the busybox tarball for full license text.
6
Denis Vlasenko687a26f2008-05-02 21:46:30 +00007# This file defines two functions, "testing" and "optional"
8# and a couple more...
Rob Landley48c61572005-11-07 08:50:53 +00009
Rob Landley48c61572005-11-07 08:50:53 +000010# The following environment variables may be set to enable optional behavior
11# in "testing":
12# VERBOSE - Print the diff -u of each failed test case.
13# DEBUG - Enable command tracing.
Denis Vlasenko687a26f2008-05-02 21:46:30 +000014# SKIP - do not perform this test (this is set by "optional")
Rob Landley48c61572005-11-07 08:50:53 +000015#
16# The "testing" function takes five arguments:
Denis Vlasenko687a26f2008-05-02 21:46:30 +000017# $1) Test description
18# $2) Command(s) to run. May have pipes, redirects, etc
19# $3) Expected result on stdout
20# $4) Data to be written to file "input"
21# $5) Data to be written to stdin
Rob Landley16890752005-09-02 00:41:53 +000022#
Denis Vlasenko687a26f2008-05-02 21:46:30 +000023# The exit value of testing is the exit value of $2 it ran.
Rob Landley16890752005-09-02 00:41:53 +000024#
25# The environment variable "FAILCOUNT" contains a cumulative total of the
Rob Landley48c61572005-11-07 08:50:53 +000026# number of failed tests.
Rob Landley16890752005-09-02 00:41:53 +000027
Rob Landley48c61572005-11-07 08:50:53 +000028# The "optional" function is used to skip certain tests, ala:
Denis Vlasenko687a26f2008-05-02 21:46:30 +000029# optional CONFIG_FEATURE_THINGY
Rob Landley48c61572005-11-07 08:50:53 +000030#
31# The "optional" function checks the environment variable "OPTIONFLAGS",
32# which is either empty (in which case it always clears SKIP) or
33# else contains a colon-separated list of features (in which case the function
34# clears SKIP if the flag was found, or sets it to 1 if the flag was not found).
Rob Landley16890752005-09-02 00:41:53 +000035
36export FAILCOUNT=0
Rob Landley48c61572005-11-07 08:50:53 +000037export SKIP=
Rob Landley16890752005-09-02 00:41:53 +000038
Denys Vlasenko6ae64262009-07-18 16:22:26 +020039# Helper for helpers. Oh my...
40
41test x"$ECHO" != x"" || {
42 ECHO="echo"
43 test x"`echo -ne`" = x"" || {
44 # Compile and use a replacement 'echo' which understands -e -n
45 ECHO="$PWD/echo-ne"
46 test -x "$ECHO" || {
47 gcc -Os -o "$ECHO" ../scripts/echo.c || exit 1
48 }
49 }
50 export ECHO
51}
52
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000053# Helper functions
54
Rob Landleycd82c3c2006-06-15 20:07:57 +000055optional()
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000056{
Denys Vlasenko8e3aff02010-05-10 11:00:11 +020057 SKIP=
58 while test "$1"; do
59 if test x"${OPTIONFLAGS/*:$1:*/y}" != x"y"; then
60 SKIP=1
61 return
62 fi
63 shift
64 done
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000065}
66
Rob Landley16890752005-09-02 00:41:53 +000067# The testing function
68
Denis Vlasenkocd0df462007-06-05 22:29:14 +000069testing()
Rob Landley16890752005-09-02 00:41:53 +000070{
Rob Landley4bb1b042006-03-16 15:20:45 +000071 NAME="$1"
Denis Vlasenko81e97a12008-05-15 22:43:48 +000072 [ -n "$1" ] || NAME="$2"
Rob Landley4bb1b042006-03-16 15:20:45 +000073
Rob Landley16890752005-09-02 00:41:53 +000074 if [ $# -ne 5 ]
75 then
Denys Vlasenkoa2215b92010-05-12 01:49:04 +020076 echo "Test $NAME has wrong number of arguments: $# (must be 5)" >&2
Denis Vlasenko81e97a12008-05-15 22:43:48 +000077 exit 1
Rob Landley16890752005-09-02 00:41:53 +000078 fi
79
Denis Vlasenko81e97a12008-05-15 22:43:48 +000080 [ -z "$DEBUG" ] || set -x
Mike Frysinger3f91d7a2005-09-24 00:52:58 +000081
Rob Landley48c61572005-11-07 08:50:53 +000082 if [ -n "$SKIP" ]
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000083 then
Rob Landley4bb1b042006-03-16 15:20:45 +000084 echo "SKIPPED: $NAME"
Rob Landley48c61572005-11-07 08:50:53 +000085 return 0
Bernhard Reutner-Fischerb47a74f2005-09-23 15:44:46 +000086 fi
87
Denis Vlasenko687a26f2008-05-02 21:46:30 +000088 $ECHO -ne "$3" > expected
89 $ECHO -ne "$4" > input
Denys Vlasenko6ae64262009-07-18 16:22:26 +020090 [ -z "$VERBOSE" ] || echo "echo -ne '$5' | $2"
Denis Vlasenko687a26f2008-05-02 21:46:30 +000091 $ECHO -ne "$5" | eval "$2" > actual
Rob Landley16890752005-09-02 00:41:53 +000092 RETVAL=$?
93
Denis Vlasenko81e97a12008-05-15 22:43:48 +000094 if cmp expected actual >/dev/null 2>/dev/null
Rob Landley16890752005-09-02 00:41:53 +000095 then
Denis Vlasenko81e97a12008-05-15 22:43:48 +000096 echo "PASS: $NAME"
97 else
Denis Vlasenko2dea01c2008-05-02 09:39:09 +000098 FAILCOUNT=$(($FAILCOUNT + 1))
Rob Landley4bb1b042006-03-16 15:20:45 +000099 echo "FAIL: $NAME"
Denis Vlasenko81e97a12008-05-15 22:43:48 +0000100 [ -z "$VERBOSE" ] || diff -u expected actual
Rob Landley16890752005-09-02 00:41:53 +0000101 fi
102 rm -f input expected actual
103
Denis Vlasenko81e97a12008-05-15 22:43:48 +0000104 [ -z "$DEBUG" ] || set +x
Mike Frysinger3f91d7a2005-09-24 00:52:58 +0000105
Rob Landley16890752005-09-02 00:41:53 +0000106 return $RETVAL
107}
Rob Landley3a324752006-03-09 22:04:33 +0000108
109# Recursively grab an executable and all the libraries needed to run it.
110# Source paths beginning with / will be copied into destpath, otherwise
111# the file is assumed to already be there and only its library dependencies
112# are copied.
113
Denis Vlasenkocd0df462007-06-05 22:29:14 +0000114mkchroot()
Rob Landley3a324752006-03-09 22:04:33 +0000115{
116 [ $# -lt 2 ] && return
117
Denis Vlasenko687a26f2008-05-02 21:46:30 +0000118 $ECHO -n .
Rob Landley4bb1b042006-03-16 15:20:45 +0000119
Rob Landley3a324752006-03-09 22:04:33 +0000120 dest=$1
121 shift
122 for i in "$@"
123 do
Denis Vlasenko2dea01c2008-05-02 09:39:09 +0000124 #bashism: [ "${i:0:1}" == "/" ] || i=$(which $i)
125 i=$(which $i) # no-op for /bin/prog
Rob Landley6bc10632006-03-18 03:01:57 +0000126 [ -f "$dest/$i" ] && continue
127 if [ -e "$i" ]
Rob Landley3a324752006-03-09 22:04:33 +0000128 then
Rob Landley3a324752006-03-09 22:04:33 +0000129 d=`echo "$i" | grep -o '.*/'` &&
130 mkdir -p "$dest/$d" &&
131 cat "$i" > "$dest/$i" &&
132 chmod +x "$dest/$i"
Rob Landley6bc10632006-03-18 03:01:57 +0000133 else
134 echo "Not found: $i"
Rob Landley3a324752006-03-09 22:04:33 +0000135 fi
136 mkchroot "$dest" $(ldd "$i" | egrep -o '/.* ')
137 done
138}
Rob Landley4bb1b042006-03-16 15:20:45 +0000139
140# Set up a chroot environment and run commands within it.
141# Needed commands listed on command line
142# Script fed to stdin.
143
Denis Vlasenkocd0df462007-06-05 22:29:14 +0000144dochroot()
Rob Landley4bb1b042006-03-16 15:20:45 +0000145{
146 mkdir tmpdir4chroot
147 mount -t ramfs tmpdir4chroot tmpdir4chroot
148 mkdir -p tmpdir4chroot/{etc,sys,proc,tmp,dev}
149 cp -L testing.sh tmpdir4chroot
150
151 # Copy utilities from command line arguments
152
Denis Vlasenko687a26f2008-05-02 21:46:30 +0000153 $ECHO -n "Setup chroot"
Rob Landley4bb1b042006-03-16 15:20:45 +0000154 mkchroot tmpdir4chroot $*
155 echo
156
157 mknod tmpdir4chroot/dev/tty c 5 0
158 mknod tmpdir4chroot/dev/null c 1 3
159 mknod tmpdir4chroot/dev/zero c 1 5
160
161 # Copy script from stdin
162
163 cat > tmpdir4chroot/test.sh
164 chmod +x tmpdir4chroot/test.sh
165 chroot tmpdir4chroot /test.sh
166 umount -l tmpdir4chroot
167 rmdir tmpdir4chroot
168}